<?php
$current_organizer="file";
require ("../lib-abdesk.php");

CheckCookie();

$errorvarname="compare_sha512_hashes_in_two_DBs_error";

session_start();

$variables_to_initialize=array(
	"counts_of_sha512_hashes", "second_db___files_sorted_by_hash", "hashes_not_found_in_first_db", "second_db___file_ids_to_get", 
);

InitializeVariables( $variables_to_initialize );



require ("../lib-files.php");
require ("lib-compare_sha512_hashes.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: compare_sha512_hashes_in_two_DBs_form.php");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}


	$add=GetFromArray($_POST, 'add');
	$edited=GetFromArray($_POST, 'edited');

if (!$add && !$edited)	//Then it was a GET and not a POST
{	

	$db=GetFromArray($_GET, 'db');
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	$varstoget_fromform=array("disknick1", "disknick2", "list_of_partial_db_names", "two_way_comparison" );

	foreach ($varstoget_fromform as $varname)
	{
		${$varname}=GetFromArray($_POST, $varname);
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
		$_SESSION[$varname]=GetFromArray($_POST, $varname);
	}
	
}

/*
if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}
*/



echo "<html><head><title>ABDesktop Compare SHA512 Hashes in Multple DBs - Results</title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File DB - Compare SHA512 Hashes in Multple DBs<br>Results</h1>";


if ( $two_way_comparison)
{
	echo "Doing two-way comparison!";
}
else
{
	echo "Only one-way comparison - making sure the hashes in the first DB are found in the second DB.";
}

echo "<p><br>";


$disknick1_with_underscores = str_replace(" ", "_", $disknick1);
$disknick2_with_underscores = str_replace(" ", "_", $disknick2);

#echo "PHP_EOL: " . PHP_EOL;

$list_of_partial_db_names=explode( PHP_EOL , $list_of_partial_db_names);

$list_of_partial_db_names = array_filter($list_of_partial_db_names, function ($name) { $trimmed_name = trim($name); if (!$trimmed_name) { return false; } else { return true; } } );

$list_of_partial_db_names = array_merge($list_of_partial_db_names);

#echo "<pre>";

#print_r($list_of_partial_db_names);

#die;

#echo "Underscored: $disknick1_with_underscores $disknick2_with_underscores ";



$current_set_number = 0;

foreach ($list_of_partial_db_names as $partial_db_name)
{	
	$current_set_number++;
	
	$partial_db_name=rtrim($partial_db_name);
	
	echo "<a name='set-$current_set_number'><hr></a><p><br>";
	
	$partial_db_name_with_underscores = str_replace(" ", "_", $partial_db_name);
	
	$full_dbname1 = $disknick1_with_underscores . "___Indexyl___" . $partial_db_name_with_underscores;
	$full_dbname2 = $disknick2_with_underscores . "___Indexyl___" . $partial_db_name_with_underscores;
	
	
	$file_db_to_use = $full_dbname1;

	echo "<p><big>$full_dbname1<p>and<p>$full_dbname2</big><p>";
		
	echo "<p>Almost connecting to $file_db_to_use...<p>";
	
	$handle=ConnectToDb($file_db_to_use, false, "dont die");
	

	
	list ( $first_db___sha512_hashes_and_file_ids, $first_db___sha512_hashes, $first_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle);
	
	
	#echo " full_dbname1 $full_dbname1   full_dbname2 $full_dbname2 ";
	
	$file_db_to_use = $full_dbname2;
	
	$handle2=ConnectToDb($file_db_to_use, false, "dont die");
	
	echo "<p>Count of 1st DB hashes: ";
	echo count($first_db___sha512_hashes);


	list ( $second_db___sha512_hashes_and_file_ids, $second_db___sha512_hashes, $second_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle2 );


	echo "<p>Count of 2nd DB hashes: ";
	echo count($second_db___sha512_hashes);
	
	
	$hashes_not_found_in_second_db = array_diff($first_db___sha512_hashes, $second_db___sha512_hashes);

	

	if ($two_way_comparison)
	{
		echo "<p>Two-way comparison!<p>";

		$hashes_not_found_in_first_db = array_diff($second_db___sha512_hashes, $first_db___sha512_hashes);
		#PrintArr($hashes_not_found_in_first_db, "Hashes not found in first DB");
	}


	echo "<p><br>";

	if (!$hashes_not_found_in_second_db && !$hashes_not_found_in_first_db)
	{
		echo "Looks OK, stopping here.";
		continue;
	}

	if ( $hashes_not_found_in_second_db )
	{
		echo "<span class='error'>Some hashes from the first DB - $full_dbname1<br>weren't found in the second DB - $full_dbname2!</span>";
	}
	else
	{	echo "<span class='notif'>All hashes from the first DB - $full_dbname1<br>were found in the second DB - $full_dbname2!</span>";

		#PrintArr($first_db___sha512_hashes, "First DB Hashes");
		#PrintArr($second_db___sha512_hashes, "Second DB Hashes");
	}
	if ($hashes_not_found_in_first_db)
	{
		echo "<span class='error'><p>Some hashes from the second DB - $full_dbname2<br>weren't found in the first DB - $full_dbname1!</span>";
	}
	else
	{	
		if ($two_way_comparison)
		{
			echo "<span class='notif'>All hashes from the second DB - $full_dbname2<br>were found in the first DB - $full_dbname1!</span>";
		}
	}


	if ( $hashes_not_found_in_second_db )
	{
		#echo "not found in second db";
		Display_Hash_Comparison($first_db___sha512_hashes_and_file_ids, $first_db___counts_of_sha512_hashes, $second_db___sha512_hashes_and_file_ids, $hashes_not_found_in_second_db, $handle, $full_dbname1, $handle2, $full_dbname2);
	}

	if ( $hashes_not_found_in_first_db )
	{
		#echo "not found in first db";
		Display_Hash_Comparison($second_db___sha512_hashes_and_file_ids, $second_db___counts_of_sha512_hashes, $first_db___sha512_hashes_and_file_ids, $hashes_not_found_in_first_db, $handle2, $full_dbname2, $handle, $full_dbname1);
	}

}




echo "<center>";
AllOrganizerNavLinks();
