<?php
$current_organizer="file";
require ("../lib-abdesk.php");

CheckCookie();

$errorvarname="compare_sha512_hashes_in_two_DBs_error";

session_start();

$variables_to_initialize=array(
	"counts_of_sha512_hashes", "second_db___files_sorted_by_hash", "hashes_not_found_in_first_db", "second_db___file_ids_to_get", 
);

InitializeVariables( $variables_to_initialize );


require ("../lib-files.php");
require ("lib-compare_sha512_hashes.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: compare_sha512_hashes_in_two_DBs_form.php");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}


	$add=GetFromArray($_POST, 'add');
	$edited=GetFromArray($_POST, 'edited');

if (!$add && !$edited)	//Then it was a GET and not a POST
{	

	$db=GetFromArray($_GET, 'db');
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	$varstoget_fromform=array("radiobox_selected_file_db1", "radiobox_selected_file_db2", "two_way_comparison");

	foreach ($varstoget_fromform as $varname)
		{
			${$varname}=GetFromArray($_POST, $varname);
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
			$_SESSION[$varname]=GetFromArray($_POST, $varname);
		}
	$file_db_to_use=$radiobox_selected_file_db1;
}

if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}


#require ("lib-output_folder_structure.php");

$handle=ConnectToDb($file_db_to_use, false, "dont die");

#list($array_of_unpaired_folder_paths_from_db, $array_of_unpaired_folder_paths_from_db_with_disks, $array_of_disknicks_of_unpaired_folder_paths_from_db, $num_of_paths)=GetUnpairedFolderPathsFromDB($handle);

echo "<html><head><title>ABDesktop $file_db_to_use Compare SHA512 Hashes in Two DBs - </title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File DB - Compare SHA512 Hashes in Two DBs</h1>
<p>";
echo "<big>$file_db_to_use<p>and<p>$radiobox_selected_file_db2</big><p>";


if ( $two_way_comparison)
{
	echo "Doing two-way comparison!";
}
else
{
	echo "Only one-way comparison - making sure the hashes in the first DB are found in the second DB.";
}
#PrintDBHeader("file");

#echo "<p>Num of paths: $num_of_paths";

#$query_to_issue = "SELECT file_id, sha512_hash, binary_sha512_hash from fileinfo where sha512_hash is not null group by sha512_hash having count(*) >= 2 ";

#$query_to_issue = "SELECT file_id, sha512_hash, binary_sha512_hash from fileinfo where sha512_hash is not null and sha512_hash having count(*) >=2 ";



list ( $first_db___sha512_hashes_and_file_ids, $first_db___sha512_hashes, $first_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle);



$file_db_to_use=$radiobox_selected_file_db2;

$handle2=ConnectToDb($file_db_to_use, false, "dont die");


echo "<p>Count of 1st DB hashes: ";
echo count($first_db___sha512_hashes);


list ( $second_db___sha512_hashes_and_file_ids, $second_db___sha512_hashes, $second_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle2 );


echo "<p>Count of 2nd DB hashes: ";
echo count($second_db___sha512_hashes);

#PrintArr($second_db___sha512_hashes, "2nd db hashes");



$hashes_not_found_in_second_db = array_diff($first_db___sha512_hashes, $second_db___sha512_hashes);

#PrintArr($hashes_not_found_in_second_db, "Hashes not found in second DB");

if ($two_way_comparison)
{
	echo "<p>Two-way comparison!<p>";

	$hashes_not_found_in_first_db = array_diff($second_db___sha512_hashes, $first_db___sha512_hashes);
	#PrintArr($hashes_not_found_in_first_db, "Hashes not found in first DB");
}


echo "<p><br>";

if (!$hashes_not_found_in_second_db && !$hashes_not_found_in_first_db)
{
	echo "Looks OK, stopping here.";
	die;
}

if ( $hashes_not_found_in_second_db )
{
	echo "<span class='error'>Some hashes from the first DB - $radiobox_selected_file_db1<br>weren't found in the second DB - $radiobox_selected_file_db2!</span>";
}
else
{	echo "<span class='notif'>All hashes from the first DB - $radiobox_selected_file_db1<br>were found in the second DB - $radiobox_selected_file_db2!</span>";

	#PrintArr($first_db___sha512_hashes, "First DB Hashes");
	#PrintArr($second_db___sha512_hashes, "Second DB Hashes");
}
if ($hashes_not_found_in_first_db)
{
	echo "<span class='error'><p>Some hashes from the second DB - $radiobox_selected_file_db2<br>weren't found in the first DB - $radiobox_selected_file_db1!</span>";
}
else
{	
	if ($two_way_comparison)
	{
		echo "<span class='notif'>All hashes from the second DB - $radiobox_selected_file_db2<br>were found in the first DB - $radiobox_selected_file_db1!</span>";
	}
}


if ( $hashes_not_found_in_second_db )
{
	#echo "not found in second db";
	Display_Hash_Comparison($first_db___sha512_hashes_and_file_ids, $first_db___counts_of_sha512_hashes, $second_db___sha512_hashes_and_file_ids, $hashes_not_found_in_second_db, $handle, $radiobox_selected_file_db1, $handle2, $radiobox_selected_file_db2);
}

if ( $hashes_not_found_in_first_db )
{
	#echo "not found in first db";
	Display_Hash_Comparison($second_db___sha512_hashes_and_file_ids, $second_db___counts_of_sha512_hashes, $first_db___sha512_hashes_and_file_ids, $hashes_not_found_in_first_db, $handle2, $radiobox_selected_file_db2, $handle, $radiobox_selected_file_db1);
}





echo "</center>";



echo "<center>";
AllOrganizerNavLinks();
