<?php

class FileObject
{
	protected $file_id;
	protected $disk;
	protected $parentdirs;
	protected $filename;
	protected $ext;
	protected $itemtype;
	protected $filesize;
	protected $filelm;
	protected $paired;
	protected $pairedname;
	protected $mirrorlocstring;
	protected $permloc;
	protected $disknick;
	protected $sha512_hash;
	protected $binary_sha512_hash;
	
	protected $mirrored=false;
	protected $counterpart_file_id;
	protected $fileobject_type;
	
	public function __construct($fileobject_type=0, $file_id=0, $disk=0, $parentdirs=0, $filename=0, $ext=0, $itemtype=0, $filesize=0, $filelm=0, $paired=0, $pairedname=0, $mirrorlocstring=0, $permloc=0, $disknick=0, $sha512_hash=0, $binary_sha512_hash=0)
    {	$vars=array("fileobject_type", "file_id", "disk", "parentdirs", "filename", "ext", "itemtype", "filesize", "filelm", "paired", "pairedname", "mirrorlocstring", "permloc", "disknick", "sha512_hash", "binary_sha512_hash");
		foreach ($vars as $var)
		{
			$this->$var=${$var};
			//echo " <b>$var:</b> "; echo $this->$var; echo "<br>";
			//EncloseOrIsNull($varname, $value, $enclosure)
		}
	//	echo "<p>";

		if ($this->fileobject_type=="main")
		{	
			$this->AddToReflectorQuery();
		}
	}
	
	public function SetCounterpartFileId($id)
	{	$this->counterpart_file_id=$id;
	}
	public function GetCounterpartFileId()
	{	return $this->counterpart_file_id;
	}
	public function GetPairedStatus()
	{	return $this->paired;
	}
	public function GetPairedFilename()
	{	return $this->pairedname;
	}
	public function GetFileId()
	{	return $this->file_id;
	}
	public function GetItemType()
	{	return $this->itemtype;
	}
	
	public function GetFilename()
	{	return $this->filename;
	}
	public function GetExt()
	{	return $this->ext;
	}
	public function GetDisk()
	{	return $this->disk;
	}
	public function GetDisknick()
	{	return $this->disknick;
	}
	public function GetMirrorLocString()
	{	return $this->mirrorlocstring;
	}
	public function GetCounterpartName()
	{	if ($this->fileobject_type=="main")
		{	$name="ReflectorFile";
		}
		else if ($this->fileobject_type=="reflector")
		{	$name="MainDBFile";
		}
		$name .= $this->counterpart_file_id;
		return $name;
	}
	public function GetCounterpartPermlocStatus()
	{	$CounterpartFile=$this->GetCounterpartName();
		global ${$CounterpartFile};
		$counterpart_permloc=${$CounterpartFile}->GetPermlocStatus();
		return $counterpart_permloc;
	}
	public function GetCounterpartDisk()
	{	$CounterpartFile=$this->GetCounterpartName();
		global ${$CounterpartFile};
		$counterpart_disk=${$CounterpartFile}->GetDisk();
		return $counterpart_disk;
	}
	public function GetCounterpartDisknick()
	{	$CounterpartFile=$this->GetCounterpartName();
		global ${$CounterpartFile};
		$counterpart_disk=${$CounterpartFile}->GetDisknick();
		return $counterpart_disk;
	}
	public function GetCounterpartParentdirs()
	{	$CounterpartFile=$this->GetCounterpartName();
		global ${$CounterpartFile};
		#echo "Counterpart File CP Parentdirs: $CounterpartFile ";
		$counterpart_parentdirs=${$CounterpartFile}->GetParentdirs();
		return $counterpart_parentdirs;
	}
	public function GetParentdirs()
	{	return $this->parentdirs;
	}
	public function GetPermlocStatus()
	{	return $this->permloc;
	}
	public function FindDBInMirrorLocString($db)
	{	
	}
}

function DoesMirrorLocStringContainDB($db, $mirrorlocstring)
{
	$tagarr=explode("; ", $mirrorlocstring);
	$disp_db=ucwords($db);
	//echo "<hr>DoesMirrorLocStringContainDB Db: $db  Disp_db: $disp_db Mirrorlocstring: $mirrorlocstring";
	if (in_array($disp_db, $tagarr))
	{	//echo "Yes MirrorLocString contains $db ";
		return true;
	}
	else
	{	//echo "No MirrorLocString doesn't contain $db  $disp_db ";
		return false;
	}
}

class ReflectorFile extends FileObject
{
	
	public function FindIfSameAsMainDBFile($id)
	{	$MainDBFile="MainDBFile$id";
		global ${$MainDBFile};
		
		$res = ${$MainDBFile}->CompareDetails($this->filename, $this->ext, $this->itemtype, $this->filesize, $this->filelm, $this->paired, $this->pairedname, $this->sha512_hash, $this->binary_sha512_hash );
		
		
	#	echo "YEEK! mainid - $id<br>reflector fn: $this->filename reflectorid: $this->file_id argh res $res <p>";
		return $res;
	}
}
class MainDBFile extends FileObject
{	
	public function CompareDetails($foreign_filename=0, $foreign_ext=0, $foreign_itemtype=0, $foreign_filesize=0, $foreign_filelm=0, $foreign_paired=0, $foreign_pairedname=0, $foreign_sha512_hash=0, $foreign_binary_sha512_hash=0 )
	{
		$vars=array("filename", "ext", "itemtype", "filesize", "filelm", "paired", "pairedname", "sha512_hash", "binary_sha512_hash");
		
		$arr_globals_needed=array ("thiswherequerypart", "filesdb_mirrorer_match_filename", "filesdb_mirrorer_match_ext", "filesdb_mirrorer_match_filesize", "filesdb_mirrorer_match_filesize_of_dirs", "filesdb_mirrorer_match_lm", "filesdb_mirrorer_accept_approx_lm", "filesdb_mirrorer_approx_lm_margin_after_exact", "filesdb_mirrorer_should_match_sha512_hashes");
		
		foreach ($arr_globals_needed as $glob)
		{	global ${$glob};
		}
		
		if ($foreign_itemtype!=$this->itemtype)
		{	#echo "Comparefail: itemtype";
			return false;
		
		}
		if ($foreign_paired!=$this->paired)
		{	#echo "Comparefail: paired";
			return false;
		}
		if ($foreign_pairedname!=$this->pairedname)
		{	#echo "Comparefail: pairedname";
			return false;
		}
		if ($filesdb_mirrorer_match_filename)
		{	if ($foreign_filename != $this->filename)
			{	#echo "Comparefail: filename  foreign: $foreign_filename  main: $this->filename ";
				return false;
			}
		}
		if ($filesdb_mirrorer_match_ext)
		{	if ($foreign_ext != $this->ext)
			{	#echo "Comparefail: ext";
				return false;
			}
		}
		if ($filesdb_mirrorer_match_filesize)
		{	if ($foreign_itemtype=="File" || ( $foreign_itemtype=="Dir" && $filesdb_mirrorer_match_filesize_of_dirs ) )
			{	if ($foreign_filesize != $this->filesize)
				{	#echo "Comparefail: filesize";
					return false;
				}
			}
		}
		if ($filesdb_mirrorer_match_lm)
		{	
			if (!$filesdb_mirrorer_accept_approx_lm)
			{
				if ($foreign_filelm != $this->filelm)
				{	#echo "Comparefail: = filelm";
					return false;
				}
				
			}
			else
			{	$filelmtime=strtotime($this->filelm);
				$laterlmtime=$filelmtime+$filesdb_mirrorer_approx_lm_margin_after_exact;
		
				$foreign_filelmtime=strtotime($foreign_filelm);
				
				if ( $foreign_filelmtime < $filelmtime || $foreign_filelmtime > $laterlmtime)
				{	#echo "Comparefail: = filelm range";
					return false;
				}
			}
		}
		
		if ($filesdb_mirrorer_should_match_sha512_hashes)
		{
			if ( $foreign_sha512_hash != $this->sha512_hash )
			{
				#echo "foreign sha512 doesn't match<br>foreign<br>$foreign_sha512_hash" . "<br>main<br>" . $his->$sha512_hash . "<br>";
				
				return false;
			}
			if ( $foreign_binary_sha512_hash != $this->binary_sha512_hash )
			{
				#echo "foreign binary sha 512 doesn't match binary sha 512";
				return false;
			}
		}
		
		//echo "MATCH FOUND YESSSS!!!";
		return true;
		
	}
	public function Hello()
	{	//echo "HIIIII";
	}
	protected function AddToReflectorQuery()
	{
		$arr_globals_needed=array ("thiswherequerypart", "filesdb_mirrorer_match_filename", "filesdb_mirrorer_match_ext", "filesdb_mirrorer_match_filesize", "filesdb_mirrorer_match_filesize_of_dirs", "filesdb_mirrorer_match_lm", "filesdb_mirrorer_accept_approx_lm", "filesdb_mirrorer_approx_lm_margin_after_exact", "filesdb_mirrorer_should_match_sha512_hashes" );
		
		$itemtype="";
		foreach ($arr_globals_needed as $glob)
		{	global ${$glob};
		}
		$thiswherequerypart .= " (";
		
		
		$thiswherequerypart .= CleanThenEncloseOrIsNull("paired", $this->paired, "\"");
		$thiswherequerypart .= " AND ";
		
		$thiswherequerypart .= CleanThenEncloseOrIsNull("itemtype", $this->itemtype, "\"");
		$thiswherequerypart .= " AND ";
		
		if ( $filesdb_mirrorer_should_match_sha512_hashes)
		{
			$thiswherequerypart .= CleanThenEncloseOrIsNull("sha512_hash", $this->sha512_hash, "\"", true);
			$thiswherequerypart .= " AND ";
			
			if ( $this->binary_sha512_hash )
			{
				$hexed_binary_sha512_hash = bin2hex($this->binary_sha512_hash);
			
				CleanInput($hexed_binary_sha512_hash);
			
				$thiswherequerypart .= "binary_sha512_hash=UNHEX(\"$hexed_binary_sha512_hash\") AND ";
			}
			else
			{
				$thiswherequerypart .= "isnull(binary_sha512_hash) AND ";
			}
			
			
			#$thiswherequerypart .= CleanThenEncloseOrIsNull("sha512_hash", $this->sha512_hash, "\"", true);
			#$thiswherequerypart .= " AND ";
		}
		if ($filesdb_mirrorer_match_filename)
		{	
			$thiswherequerypart .= CleanThenEncloseOrIsNull("filename", $this->filename, "\"", true);
			$thiswherequerypart .= " AND ";
		}
		
		if ($filesdb_mirrorer_match_ext)
		{	
			$thiswherequerypart .= CleanThenEncloseOrIsNull("ext", $this->ext, "\""); //21:23:30 9/25/2012. Should maybe force an enclosure here too, for any numeric exts...
			$thiswherequerypart .= " AND ";
		}
		if ( ($filesdb_mirrorer_match_filesize && $itemtype=="File") || ($itemtype=="Dir" && $filesdb_mirrorer_match_filesize_of_dirs && $filesdb_mirrorer_match_filesize) )
		{
			$thiswherequerypart .= CleanThenEncloseOrIsNull("filesize", $this->filesize, "\"");
			$thiswherequerypart .= " AND ";
		}
		if ($filesdb_mirrorer_match_lm)
		{
			if (!$filesdb_mirrorer_accept_approx_lm)
			{	$thiswherequerypart .= CleanThenEncloseOrIsNull("filelm", $this->filelm, "\"");
				$thiswherequerypart .= " AND ";
			}
			else
			{	$filelmtime=strtotime($this->filelm);
				$laterlmtime=$filelmtime+$filesdb_mirrorer_approx_lm_margin_after_exact;
				$laterlmdate=date("Y-m-d H:i:s", $laterlmtime);
				$thiswherequerypart .= "filelm >= \"$this->filelm\" AND filelm <= \"$laterlmdate\" AND ";
			}
		}
		$thiswherequerypart=substr($thiswherequerypart, 0, -4);  // " AND "
		
		$thiswherequerypart .= " ) 
		OR ";
		
		
		
		
		
	#	echo "<p>THISWHEREQUERYPART IN LIB-MIRRORER: $thiswherequerypart --<p>";
	}
	
	public function GetFilepath()
	{
		$res=MakeFilepath($this->disknick, $this->disk, $this->parentdirs);
		return $res;
	}
	
	
	public function SetAsMirrored()
	{	$this->mirrored=true;
	}
	
	public function IsThisMirrored()
	{	if ($this->mirrored)
		{	return true;
		}
		else
		{	return false;
		}
	}
}


function GetAdditionalReflectorWHEREStuff($thiswherequerypart=0)
{	global $filesdb_mirrorer_only_mirror_permloc_files, $filesdb_mirrorer_allow_mirroring_of_dirs;

//	if ($thiswherequerypart!=0)
	if ($thiswherequerypart)
	{	
		$thiswherequerypart .= " AND ";
	}
	else
	{	$thiswherequerypart = " WHERE ";
	}
	if ($filesdb_mirrorer_only_mirror_permloc_files)
	{	$thiswherequerypart .= "fileinfo.permloc='n' AND ";
	}
	$thiswherequerypart .= "fileinfo.mirrored!='y' AND fileinfo.mirrored!='na' AND (fileinfo.itemtype='File' ";
	if ($filesdb_mirrorer_allow_mirroring_of_dirs)
	{	$thiswherequerypart .= "OR (fileinfo.itemtype='Dir' AND fileinfo.paired='n'))    ";
	}
	else
	{	$thiswherequerypart .= ")";
	}
	return $thiswherequerypart;
}

function GetAdditionalMirrorerWHEREStuff($thiswherequerypart=0)
{	global $filesdb_mirrorer_only_mirror_permloc_files, $filesdb_mirrorer_allow_mirroring_of_dirs, $doing_reverse_mirror_command, $doing_mirror_command;

	//if ($thiswherequerypart!=0)
	if ($thiswherequerypart)
	{	$thiswherequerypart .= " AND ";
	}
	else
	{	$thiswherequerypart = " WHERE ";
	}
		
	if ($doing_mirror_command)
	{
		#echo "Again thiswhere  $thiswherequerypart ";
		
		if ($filesdb_mirrorer_only_mirror_permloc_files)
		{	$thiswherequerypart .= "fileinfo.permloc='y' AND ";
		}
		$thiswherequerypart .= "fileinfo.mirrored!='y' AND fileinfo.mirrored!='na' AND (fileinfo.itemtype='File' ";
		if ($filesdb_mirrorer_allow_mirroring_of_dirs)
		{	$thiswherequerypart .= "OR (fileinfo.itemtype='Dir' AND fileinfo.paired='n'))    ";
		}
		else
		{	$thiswherequerypart .= ")";
		}
	}
	else if ($doing_reverse_mirror_command)
	{	#echo "Revmir thiswhere  $thiswherequerypart ";
		//if ($filesdb_mirrorer_only_mirror_permloc_files)
		//{	
		$thiswherequerypart .= "fileinfo.permloc='n' AND ";
		//}
		$thiswherequerypart .= "fileinfo.mirrored!='y' AND fileinfo.mirrored!='na' AND (fileinfo.itemtype='File' ";
		if ($filesdb_mirrorer_allow_mirroring_of_dirs)
		{	$thiswherequerypart .= "OR (fileinfo.itemtype='Dir' AND fileinfo.paired='n'))    ";
		}
		else
		{	$thiswherequerypart .= ")";
		}
	}
//	echo "Again thiswhere  $thiswherequerypart ";
	return $thiswherequerypart;
}

