<?php
$current_organizer="url";
require ("../lib-abdesk.php");
CheckCookie();
require ("lib-search.php");
require ("../lib-manuals.php");


echo "<html><head><title>Manual - Links Organizer</title>
<link rel=stylesheet href='css/l.css' type='text/css'>

<style type=\"text/css\">
.c
{	font-weight: bold;
	font-family:  monospace;
}
</style></head>

<body><center>";

AllOrganizerNavLinks(); 

echo "<h1>Links Search Commands</h1></center>
<p>
<div class=\"navanchs\"><a href=\"#complete-search-command-list\">Complete Search Command List</a> | <a href=\"#complete-edit-command-list\">Complete Edit Command List</a>
<p>
<a href=\"#mysqlcrashtip\">A Tip To Make MySQL Crashes Less Terrible</a> | <a href=\"#formtips\">Tips for Filling Out  Forms</a>
<p>
<a href=\"#urlsearch\">URL Search Commands</a> | <a href=\"#linkdatasearch\">Link Data Search Commands</a><br>
<a href=\"#displayoptions\">Display Option Commands</a><br>
<a href=\"#searchformoptions\">Search Form Option Commands</a>: <a href=\"#orders\">Order Commands</a> | <a href=\"#onlys\">Only Commands</a> | <a href=\"#includes\">Include Commands</a> | <a href=\"#excludes\">Exclude Commands</a> | <a href=\"#dates\">Date Commands</a><br><a href=\"#tagsearch\">Tag Search Commands</a>
<p>
<a href=\"#editcommands\">Edit Commands</a> - 
<a href=\"#selectingthelinkrecordsthatwillbeedited\">Selecting The Link Records That Will Be Edited</a> - <a href=\"#whatthedifferenteditbuttonsdo\">What the Different Edit Buttons Do</a> - <a href=\"#nontageditcommands\">Non-Tag Edit Commands</a> - <a href=\"#tageditcommands\">Tag Edit Commands</a>
<p>
<a href=\"#explanation-of-syms\">Explanation of Symbols</a> - <a href=\"#explanation-of-cats\">Explanation of Categories</a></div>
<p>
<div id='maintext'>";

echo "<p><center><a name='complete-search-command-list'></a><H3>Complete Search Command List</h3></center>";

echo "<table>";

foreach ($list_allcommandarrays as $arr)
{
	echo "<tr><td  align=right><b>$arr</b><td align=left>";
	
	foreach ( ${$arr} as $command )
	{
		echo " $command ";
	}
	#$alleditcommands = array_merge( $alleditcommands, ${$arr} );
}
echo "</table>";

echo "<p><br>";



echo "<p><center><a name='complete-edit-command-list'></a><H3>Complete Edit Command List</h3></center>";

echo "<table>";

foreach ($list_alleditcommandarrays as $arr)
{
	echo "<tr><td  align=right><b>$arr</b><td align=left>";
	
	foreach ( ${$arr} as $command )
	{
		echo " $command ";
	}
	#$alleditcommands = array_merge( $alleditcommands, ${$arr} );
}
echo "</table>";

echo "<p><br>";

PrintIntro("Links", "ABLOQL");
PrintDynamicallyGeneratedBit();

PrintMysqlCrashTip();
PrintFormTips("Links");


echo "<p>
<br>
<a name=\"urlsearch\"></a>
<hr width=75%><p><br>";

echo "<center><h2>URL Search Commands</h2></center><p>";


PrintCommandsArray($hostnamecommands); 

echo " - Finds links where the hostname is like all of the arguments you entered.";

echo "<p>
<ul>Example:<br>
<span class=\"c\">hosts en, wikipedia</span>
<p>
Finds links which have the text *en* and *wikipedia* somewhere in the host name.</ul><p><br>";


PrintCommandsArray($hostnameorcommands); 

echo " - Finds links where the hostname is like any of the arguments you entered.<p>";

echo "<p>
<ul>Example:<br>
<span class=\"c\">hosts www.astroblahhh, wikipedia</span>
<p>
Finds links which have the text *www.astroblahhh* or *wikipedia* somewhere in the host name.</ul><p>";

PrintCommandsArray($hostnamexcommands);

echo " - Finds links where the hostname is exactly the same as any of the arguments you entered.<p><br>";


PrintCommandsArray($suffixcommands);

echo " - Finds links where the suffix (like \"com\" or \"net\") is exactly the same as any of the arguments you entered.  Don't include periods.";
echo "<p>
<ul>Example:<br>
<span class=\"c\">suffix net, edu</span>
<p>
Finds links with have the suffix \"net\" or \"edu\".</ul><p><br>";


PrintCommandsArray($pathcommands);

echo " - Finds links where the path (any of the directories or the file name; the hostname is excluded) contains strings like all of the arguments you entered.
<p>
<ul>Example:<br>
<span class=\"c\">path forum, tech</span>
<p>

Finds links which have *forum* and *tech* somewhere in the path.</ul><p>";

PrintCommandsArray($pathorcommands);

echo " - Finds links where the path contains strings like any of the arguments you entered.
<p>
<ul>Example:<br>
<span class=\"c\">path forum, blog</span>
<p>

Finds links which have *forum* or *blog* somewhere in the path.</ul><p><br>";

PrintCommandsArray($pathxcommands );

echo " - Finds links whose exact path is any of the arguments you entered.  Capitalization doesn't matter.<p><br>";


PrintCommandsArray($filenamecommands);

echo " - Finds links where the file name contains strings like all of the arguments you entered.<p>";

PrintCommandsArray($filenameorcommands);

echo " - Finds links where the file name contains strings like any of the arguments you entered.<p>";

PrintCommandsArray($filenamexcommands);

echo " - Finds links where the file name is exactly the same as any of the arguments you entered. Capitalization doesn't matter.  You must include the file extension.<p><br>";

echo "<a name='linkdatasearch'></a><hr width=25%><p><br>";

echo "<center><h2>Link Data Search Commands</h2></center><p>";

PrintCommandsArray($titlecommands);

echo " - Finds links where the title contains strings like all of the arguments you entered.<p>";

PrintCommandsArray($titleorcommands);

echo " - Finds links where the title contains strings like any of the arguments you entered.<p>";

PrintCommandsArray($titlexcommands);

echo " - Finds links where the title is exactly the same as any of the arguments you entered. Capitalization doesn't matter.<p><br>";


PrintCommandsArray($pagetypecommands);

echo " - Finds links where the page type contains strings like all of the arguments you entered.<p>";

PrintCommandsArray($pagetypeorcommands);

echo " - Finds links where the page type contains strings like any of the arguments you entered.<p>";

PrintCommandsArray($pagetypexcommands);

echo " - Finds links where the page type is exactly the same as any of the arguments you entered. Capitalization doesn't matter.<p><br>";


PrintCommandsArray($shortdesccommands);

echo " - Finds links where the shortdesc contains strings like all of the arguments you entered.  When this command is issued without arguments, finds all links whose shortdesc isn't null.<p>";

PrintCommandsArray($shortdescorcommands);

echo " - Finds links where the shortdesc contains strings like any of the arguments you entered.<p>";

PrintCommandsArray($shortdescxcommands);

echo " - Finds links where the shortdesc is exactly the same as any of the arguments you entered. Capitalization doesn't matter.";


echo "<p><br><a name=\"displayoptions\"></a>
<hr width=75%><p><br>
<center><h2>Display Option Commands</h2></center>
<p>
<br>";

PrintCommandsArray($nosymbolscommands);

echo " - Uses text instead of Unicode symbols.<p>";

PrintCommandsArray($usesymbolscommands);

echo " - The default setting. Uses Unicode symbols instead of text.";

echo "<p><br><a name=\"searchformoptions\"></a>
<hr width=75%><p><br>
<center><h2>Search Form Option Commands</h2>
<p>
Commands which change (or can change) the settings in the search form.</center>
<p>
<br>";

PrintCommandsArray($pagenumcommands);

echo " - Goes to the page number you specified.<p>";

PrintCommandsArray($urlnumcommands);

echo " - Changes the number of links displayed per page.<p><br>";


PrintCommandsArray($ignorecbcommands);

echo " - Causes the search to ignore all the Include checkboxes, Only checkboxes, and Order checkboxes.<br>";

PrintCommandsArray($ignoreincludecbcommands);

echo " - Ignores all the Include checkboxes.<br>";

PrintCommandsArray($ignoreonlycbcommands);

echo " - Ignores all the Only checkboxes.<br>";

PrintCommandsArray($ignoreordercbcommands);

echo " - Ignores all the Order checkboxes.<p>";

echo "<p><br>
<a name=\"orders\"></a>
<hr width=25%><p><br>

<center><h3>Order Commands</h3></center>
<p>";

PrintCommandsArray($lastreadcommands);

echo " - Orders the links list by last-read date in ascending order, with recently-read links at the bottom, and unread or less recently read links at the top.<p><br>";

PrintCommandsArray($ascs); br();
PrintCommandsArray($descs);

echo " - Orders the links list in ascending or descending order.<p><br>";

PrintCommandsArray($ordercommands);

echo " - Orders the links list by whatever orders you specify.  The names and abbreviations you can use are:<p>";
echo "<center><table cellpadding=2><tr>";

$x=0;
foreach ($order_abrev_arrs as $arr => $nonabrevname)
{	if ($x%3==0)
	{	echo "<tr>";
	}
	echo "<th>$nonabrevname<td>"; PrintCommandsArray(${$arr} );
	$x++;
}
echo "</table></center>";

echo "<p>Optionally, you follow each order argument with an abbreviation for ascending or descending order:<br><blockquote>";

PrintCommandsArray($ascs); br();
PrintCommandsArray($descs);

echo "</blockquote>";

echo "<p>
Example:<p>

<blockquote><span class=\"c\">order liking desc, title asc</span></blockquote>";


echo "<p><br>
<a name=\"onlys\"></a>
<hr width=25%><p><br>

<center><h3>Only Commands</h3></center>
<p>";

PrintCommandsArray($onlycommands);

echo " - Makes it so the link list includes only the links of the categories you specify.  The cateegory names and abbreviations you can use are:<p>";
echo "<center><table cellpadding=2><tr>";

$x=0;
foreach ($abrev_arrs as $arr => $nonabrevname)
{	if ($x%3==0)
	{	echo "<tr>";
	}
	echo "<th>$nonabrevname<td>"; PrintCommandsArray(${$arr} );
	$x++;
}
echo "</table></center>";

echo "<p><br>
<a name=\"includes\"></a>
<hr width=25%><p><br>

<center><h3>Include Commands</h3></center>
<p>";

PrintCommandsArray($includecommands);

echo " - Makes it so the search is permitted to include links of the categories you specify that are normally excluded by default.  The cateegory names you can use are:<p><blockquote>";

PrintCommandsArray($includeattributes);

echo "</blockquote><p>You can also abbreviate the names in the ways indicated in preceding sections.<p><br>";

PrintCommandsArray($includeallcommands);

echo " - Causes all the above categories to be included.<p>";

PrintCommandsArray($includeintcommands);

echo " - Causes the interesting categories (namely, Maybe, Aside, and Arc) to be included.<p>";

PrintCommandsArray($includequestioncommands);

echo " - Causes the categories of unknown or questionable interest (Repository, Trivial, Travelog) to be included.";

echo "<p><br>
<a name=\"excludes\"></a>
<hr width=25%><p><br>

<center><h3>Exclude Commands</h3></center>
<p>";

PrintCommandsArray($excludecommands);

echo " - Excludes links of the categories you specify.  The cateegory names you can use are:<p>";

echo "<center><table cellpadding=2><tr>";

$x=0;
foreach ($abrev_arrs as $arr => $nonabrevname)
{	if ($x%3==0)
	{	echo "<tr>";
	}
	echo "<th>$nonabrevname<td>"; PrintCommandsArray(${$arr} );
	$x++;
}
echo "</table></center>";

echo "<p><br>";

PrintCommandsArray($excludeallmaincats);

echo " - Excludes all links which belong to any of the 7 main categories (aesthetic, utilit, educational, forfun, humorous, news, curio).<p><br>";

PrintCommandsArray($excludeothermaincats);

echo " - Excludes all links belonging to any of the 7 main categories other than the categories you've used as an Only filter.
<p>
So, if you want to look exclusively at links which belong to both Aesthetic and Utilitarian categories but no other categories, you would input these commands:
<p>
<blockquote><span class=\"c\">igo;; only aes, util;; xoc</span></blockquote>
<p>
The \"igo\" command is there so the search will ignore any Only checkboxes that are checked.  Without it, any filled checkboxes you haven't noticed and unchecked could interfere with your search.<p><br>";

PrintCommandsArray($excludeboringcommands);

echo " - Excludes the most boring categories (Clutter Pile, Junk Pile, and Gone).<p><br>";

PrintCommandsArray($excludesubtagcommands);

echo " - Makes it so when conducting a tag search, subtags (that is, tags which were made by splitting a multi-word tag into separate tags) will be excluded from being searched.
<p>
So, if you do a tag search for a tag named \"Guitar\", then if something is tagged only with \"Electric Guitar\" it won't be found.<p><br>";

PrintCommandsArray($ignorecbcommands);

echo " - Causes the search to ignore all the Include checkboxes, Only checkboxes, and Order checkboxes.<br>";

PrintCommandsArray($ignoreincludecbcommands);

echo " - Ignores all the Include checkboxes.<br>";

PrintCommandsArray($ignoreonlycbcommands);

echo " - Ignores all the Only checkboxes.<br>";

PrintCommandsArray($ignoreordercbcommands);

echo " - Ignores all the Order checkboxes.<p>";


echo "<p><br>
<a name=\"dates\"></a>
<hr width=25%><p><br>

<center><h3>Date Commands</h3></center>
<p>";

PrintCommandsArray($coldatecommands);

echo " - A  command which allows you to find links whose earliest dates of collection timestamps are equal to, older than, or newer than, dates you specify.  The date parser is pretty flexible, so you can use a variety of date formats.
<p>
Possible comparisons you can use: ";

PrintCommandsArray($possiblecomparisons);

echo "<p>Examples:
<p>
<blockquote><span class=\"c\">col Jan 1 2009 12 PM</span><br>
Find all links whose earliest dates of collection timestamps are exactly Jan. 1, 2009 at 12:00:00 PM.
<p>
<span class=\"c\">col < Feb 2 2000 5 PM</span><br>
Find all links whose earliest dates of collection timestamps are earlier than Feb. 2, 2000 at 5:00:00 PM.
<p>
<span class=\"c\">col >= July 1 2002 5:43:22 AM; <= May 1 2003 2:15:42 AM</span><br>
Finds all links whose earliest dates of collection timestamps are newer than or equal to July 1, 2002 at 5:43:22 AM and older than or equal to May 1, 2003 at 2:15:42 AM.</blockquote><p><br>";

echo "<p><br>
<a name=\"tagsearch\"></a>
<hr width=75%><p><br>
<center><h2>Tag Search Commands</h2></center><p><br>The first set of commands will find files which have all of the tags you entered, the second set will find files which have any of the tags you entered.<p>";

PrintCommandsArray($anytagcommands); br();
PrintCommandsArray($anytagorcommands); p(); br();

PrintCommandsArray($maintagcommands); br();
PrintCommandsArray($maintagorcommands); p(); br();


PrintCommandsArray($othertagcommands); br();
PrintCommandsArray($othertagorcommands); p(); br();


PrintCommandsArray($projectagcommands); br();
PrintCommandsArray($projectagorcommands); p(); br();


PrintCommandsArray($bundletagcommands); br();
PrintCommandsArray($bundletagorcommands); echo " - These sets find files which have the tags you input as bundle tags (both the tags shown as green, boxed text, and the \"other bundle\" tags).<p><br>";

PrintCommandsArray($otherbundletagcommands); br();
PrintCommandsArray($otherbundletagorcommands); echo " - These only find other bundle tags and ignore regular bundle tags.  I'm not sure there's much reason to do that, though.<p><br>";


PrintCommandsArray($authortagcommands); br();
PrintCommandsArray($authortagorcommands); p(); br();


PrintCommandsArray($languagetagcommands); br();
PrintCommandsArray($languagetagorcommands); p(); br();

PrintCommandsArray($tofortagcommands); br();
PrintCommandsArray($tofortagorcommands); p(); br();

PrintCommandsArray($excludesubtagcommands);

echo " - Makes it so when conducting a tag search, subtags (that is, tags which were made by splitting a multi-word tag into separate tags) will be excluded from being searched.
<p>
So, if you do a tag search for a tag named \"Guitar\", then if something is tagged only with \"Electric Guitar\" it won't be found.";


echo "
<p>
<br>
<a name=\"editcommands\"></a>
<hr width=75%><p><br>";

echo "<center><h1>Edit Commands</h1></center></center>";

echo "Below are commands you can use in the mass editor text box in the lister.  Be very careful when using the mass editor - there's no built-in way to undo anything you do, and there still might be glitches that I'm unaware of.  The only way to reverse an edit is if you have a backup copy of your database as it was before you executed the edit.";

echo "<p><br><hr width=25%><p><br>

<a name=\"selectingthelinkrecordsthatwillbeedited\"></a>
<center><h2>Selecting The Link Records That Will Be Edited</h2></center>
<p>
The most typical way to select the links that will be affected by your edit commands is just to click on them in the lister.  You can tell if an idea is selected in two ways - the link info will be highlighted (if you have JavaScript turned on), and/or a check will be in the checkbox amongst the link info.
<p>
There are also two (sets of) commands you can use to select records.<p>";

PrintCommandsArray($editallcommands); 

echo " - Disabled by default; must be enabled by setting the $" . "url_organizer__allows_allresults_mass_edit_command variable in lib-abdesk.php to true.  This is the most all-encompassing (and dangerous) link selection command.  All the links resulting from your search will be edited.  Editing checked items or using the page command is faster and less dangerous, though.<p>";

PrintCommandsArray($editpagecommands); 

echo " - These edit all the items on the lister page you're on, instead of the entire search.";


echo "<p><br><hr width=25%><p><br>

<a name=\"whatthedifferenteditbuttonsdo\"></a>
<center><h2>What the Different Edit Buttons Do</h2></center>
<p>
There are three different buttons you can click to execute an edit.  If having three different edit buttons bothers you, you can edit the source code of list-files.php to get rid of them, either by deleting them or by commenting them out.
<p>
Find the buttons in the source code by searching for the text \"&lt;p>&lt;br>&lt;br>Edit Buttons:&lt;br>\" (without quotes).  To comment out HTML code, you put an exclamation point after the &lt; for a tag.  Find the beginning of the code for the buttons - \"&lt;input\" [...] (without quotes) - and put an exclamation point after the &lt; sign, like \"&lt!input\" [...].
<p>
<ul><li><b>Edit</b> - This will execute the edit and display the list with an updated count.  Not all edits you do will modify the count, though, so in such a case, you would be better off clicking No Recount.
<p>
<li><b>No Recount</b> - This will execute the edit and display the list without recounting the items. 2nd fastest.
<p>
<li><b>No List</b> - The fastest edit button.  This will execute the edit, but not recount the items or even show the list.  This is good when you're editing items which were yielded by a slow search, so the lister won't have to annoyingly repeat that search.</ul>";


echo "<p><br><hr width=25%><p><br>";

echo "<a name=\"nontageditcommands\"></a>
<center><h2>Non-Tag Edit Commands</h2></center>
<p>";

PrintCommandsArray($onlycommands); 

echo " - Makes it so the link records selected will be given the attributes you supply. You'll be able to use most of these <a href=\"#onlys\">attributes and abbreviations</a>.  Negative arguments are (or should be) ignored.<p>";

PrintCommandsArray($excludecommands); 

echo " - Makes it so the link records selected will be stripped of the attributes you state. You'll be able to use most of these <a href=\"#excludes\">attributes and abbreviations</a>.  Negative arguments are (or should be) ignored.<p>";


PrintCommandsArray($titlecommands);
echo " - Changes the title of all selected link records to whatever you specify.<p>";

PrintCommandsArray($likingcommands);
echo " - Changes the Liking rating of all selected link records to whatever you specify.<p>";

PrintCommandsArray($qualitycommands);
echo " - Changes the Quality rating of all selected link records to whatever you specify.<p>";

PrintCommandsArray($humorousnesscommands);
echo " - Changes the Humorousness rating of all selected link records to whatever you specify.<p>";



echo "<p><br><hr width=25%><p><br>

<a name=\"tageditcommands\"></a>
<center><h2>Tag Edit Commands</h2></center>
<p>
Enter negative arguments to specify a tag which should be removed.<p>";

PrintCommandsArray($maintagcommands); 
PrintCommandsArray($anytagcommands); 

echo " - Adds or removes main tags.<p>";

PrintCommandsArray($othertagcommands); p();

PrintCommandsArray($projectagcommands); p();

PrintCommandsArray($bundletagcommands); 
echo " - Adds or removes bundle tags (the tags which are shown as green, boxed text).<p>";

PrintCommandsArray($otherbundletagcommands); 
echo " - Adds or removes other bundle tags (the bundle tags which aren't shown as green, boxed text).<p>";

PrintCommandsArray($authortagcommands); p();

PrintCommandsArray($languagetagcommands); p();

PrintCommandsArray($origintagcommands); p();

PrintCommandsArray($loctagcommands); p();

PrintCommandsArray($tofortagcommands); p();
br();

PrintCommandsArray($titleandtagcommands);

echo " - This uses the first argument as both a title and a main tag, and uses the rest of the arguments as main tags.";


echo "<p><br>
<a name=\"explanation-of-syms\"></a>
<hr width=75%><p><br>
<center><h2>Explanation of Symbols</h2><p><br>";

echo "<table><tr><td><div class='catsymb'>
<span class='necb'>&#x2623</span> 
Necessity<br><span class='curiob'>&#x2665</span> 
Liking<br>
<span class='intrb'>&#x262F</span> Interest<br><span class='qualb'>&#x265B</span> Quality<br>
<span class='curiob'>&#x2619</span> Curio<br>
<span class='newsb'>&#x26A1</span> News

</div>
<td><div class='catsymb'><span class='aesb'>&#x2640</span> Beauty<br><span class='utilb'>&#x2702</span> Usefulness<br><span class='edub'>&#x270E</span> Educational Value<br><span class='funb'>&#x2658</span> Fun<br><span class='humb'>&#x263B</span> Humorous</div></table>";



echo "<p><br>
<a name=\"explanation-of-cats\"></a>
<hr width=75%><p><br>
<h2>Explanation of Categories</h2></center><p><br>";

echo "<ul><li>AO - Links marked as being in Archive.org.  (Excludes links that are marked as being in Archive.org but unavailable, or marked as definitely not in Archive.org).
<p>
<li>Site - Links intended for my website but not yet used.
<p>
<li>Sav - Links whose content I've saved as a file.</ul>
<p>
<br>";

echo "There are 9 categories which are hidden from the link list by default (unless you click the Long List link instead of List Links):
<p>
<ul><li>Repository - For newly-added links, or any links whose records I want to add more info to later.
<p>
<li>Trivial - For anything rather unimportant.  Not necessarily boring or bad, probably just frivolous or overall insignificant.
<p>
<li>Maybe - For anything I think I might have an eventual use for someday.
<p>
<li>Archive - For stuff with a distinct purpose, like being used in a specialized collection or for a particular project, but which I also want out of the way and not cluttering my main bookmark list.
<p>
<li>Aside - For stuff which isn't frequently-used or useful enough to have in the main list, but is otherwise good stuff with at least a vague reason for me to keep it.
<p>
<li>Travelog - If someone ever develops a way to automatically log links you visit (similar to the <a href=\"http://w-shadow.com/blog/2009/02/07/anti-privacy-beta/\">Anti-Privacy</a> script at <a href=\"http://w-shadow.com/\">W-Shadow.com</a>), this might be a good category to automatically assign the logged links to.  (Then again, maybe a whole new category would be better).
<p>
I tend to use it for links which aren't quite useless enough to go in the Clutter Pile or Junk Pile, but which aren't really interesting or useful enough to go in the Aside pile.
The way I use it, it tends to mean \"been there, done that, probably don't need to see it again\".
<p>
<li>Clutter Pile - For actual clutter that I would be close to not missing if I had to part with it.
<p>
<li>Junk Pile - Actual junk which is pretty much useless.
<p>
<li>Gone - For links which are not only dead, but which are definitely not in Archive.org.<p><br><center>";

AllOrganizerNavLinks();

